package com.ruoyi.web.controller.moonshot;


import com.ruoyi.common.config.RuoYiConfig;
import com.ruoyi.common.core.domain.AjaxResult;
import com.ruoyi.common.utils.file.FileUploadUtils;
import com.ruoyi.common.utils.file.FileUtils;
import com.ruoyi.common.utils.moonshot.Client;
import com.ruoyi.common.utils.moonshot.vo.FileUploadResult;
import com.ruoyi.framework.config.ServerConfig;
import com.ruoyi.web.controller.common.CommonController;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import org.springframework.web.multipart.MultipartFile;

import java.io.File;

@RestController
@RequestMapping("/moonshot/file")
public class MoonshotFileController {

    private static final Logger log = LoggerFactory.getLogger(CommonController.class);

    @Autowired
    private ServerConfig serverConfig;

    @Value("${moonshot.api_key}")
    private String API_KEY;

    /**
     * 通用上传请求（单个）
     */
    @PostMapping("/upload")
    public AjaxResult uploadFile(MultipartFile file) throws Exception
    {
        AjaxResult ajax = AjaxResult.success();
        try
        {
            if (API_KEY == null) {
                System.out.println("Please set MOONSHOT_API_KEY env");
                ajax.put("API_KEY","接口API_KEY不存在");
                return ajax;
            }
            Client client = new Client(API_KEY);

            FileUploadResult resuat = client.uploadFile(file);



            ajax.put("FileUploadResult", resuat);
            return ajax;
        }
        catch (Exception e)
        {
            return AjaxResult.error(e.getMessage());
        }
    }


}
