package com.ruoyi.common.utils.moonshot;

import cn.moonshot.platform.util.MoonshotAiUtils;

import com.ruoyi.common.enums.ChatMessageRole;
import com.ruoyi.common.utils.moonshot.vo.*;

import java.io.File;
import java.io.IOException;
import java.util.Arrays;
import java.util.List;

public class MoonshotDemoMain {

    public static void main(String... args) throws IOException {

        String apiKey = "sk-6RRz9mTfCnit49IQwpxs3oa2JHqfOVuQvWDy3HauX2CExvwg";
        if (apiKey == null) {
            System.out.println("Please set MOONSHOT_API_KEY env");
            return;
        }
        Client client = new Client(apiKey);

        File file = new File("/D:/szty/695b2905-dda7-4e7d-b321-641ea3b06c74.pdf");
        FileUploadResult resuat = client.uploadFile(file);

        if(resuat.getStatus().equals("ok")) {
            String fileId = resuat.getId();

            String fileContent = MoonshotAiUtils.getFileContent(fileId,client.getApiKey());
            System.out.println(fileContent);
            final List<ChatCompletionMessage> messages = Arrays.asList(
                    new ChatCompletionMessage(ChatMessageRole.SYSTEM.value(),
                            "你是计算机行业专业面试官，提供一套面试题，并根据回复的答案进行分析和人员的能力程度"),
                    new ChatCompletionMessage(ChatMessageRole.SYSTEM.value(),
                            fileContent),
                    new ChatCompletionMessage(ChatMessageRole.SYSTEM.value(),
                            ""),
                    new ChatCompletionMessage(ChatMessageRole.USER.value(),
                            "请描述一下回答情况，水平")
            );

//        try {
//            ChatCompletionResponse response = client.ChatCompletion(new ChatCompletionRequest(
//                    "moonshot-v1-8k",
//                    messages,
//                    50,
//                    0.3f,
//                    1
//            ));
//            for (ChatCompletionChoice choice : response.getChoices()) {
//                System.out.println(choice.getMessage().getContent());
//            }
//        } catch (IOException e) {
//            e.printStackTrace();
//        }

            try {
                client.ChatCompletionStream(new ChatCompletionRequest(
                        "moonshot-v1-32k",
                        messages,
                        1024,
                        0.3f,
                        1
                )).subscribe(
                        streamResponse -> {
                            if (streamResponse.getChoices().isEmpty()) {
                                return;
                            }
                            for (ChatCompletionStreamChoice choice : streamResponse.getChoices()) {
                                String finishReason = choice.getFinishReason();
                                if (finishReason != null) {
                                    System.out.print("finish reason: " + finishReason);
                                    continue;
                                }
                                System.out.print(choice.getDelta().getContent());
                            }
                        },
                        error -> {
                            error.printStackTrace();
                        },
                        () -> {
                            System.out.println("complete");
                        }
                );
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }


}
